#ifndef HEADER_313A6ABB4C116A38
#define HEADER_313A6ABB4C116A38

/***************************************************************
 * Name:      bitmapcombobox.h
 * Purpose:   Defines Dialog combobox
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-27
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef BITMAPCOMBOBOX_H
#define BITMAPCOMBOBOX_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/validate.h>
#include <wx/bmpcbox.h>

class datosBitmapComboBox
{
    public:
        datosBitmapComboBox() {}
        datosBitmapComboBox(const wxString& valor, const wxArrayString& a, const wxArrayInt& c) :
            opcion(valor), lista(a), color(c) {}

    //private:
        wxString opcion;
        wxArrayString lista;
        wxArrayInt color;
};

class bcbValidator : public wxValidator {
public:
    bcbValidator(wxString *v = nullptr);
    virtual wxObject* Clone() const { return new bcbValidator(*this); }
    virtual bool TransferFromWindow();
    virtual bool TransferToWindow();
    virtual bool Validate(wxWindow * parent);
private:
    wxString* m_valor;
    DECLARE_DYNAMIC_CLASS( bcbValidator )
    DECLARE_EVENT_TABLE()
};

class bitmapcombobox : public wxDialog
{
    public:
        bitmapcombobox(wxWindow *wnd, datosBitmapComboBox &datos);
        virtual ~bitmapcombobox();

    protected:
        enum
        {
            idBitmapComboBox = 1000
        };
        datosBitmapComboBox& data;
        wxBitmapComboBox* m_comboBox;

    private:
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // BITMAPCOMBOBOX_H
#endif // header guard

