/***************************************************************
 * Name:      combobox.h
 * Purpose:   Defines Dialog combobox
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-27
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef COMBOBOX_H
#define COMBOBOX_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/validate.h>

class datosComboBox
{
    public:
        datosComboBox() {}
        datosComboBox(const wxString& valor, const wxArrayString& a) : opcion(valor), lista(a) {}

    //private:
        wxString opcion;
        wxArrayString lista;
};

class cbValidator : public wxValidator {
public:
    cbValidator(wxString *v = nullptr);
    virtual wxObject* Clone() const { return new cbValidator(*this); }
    virtual bool TransferFromWindow();
    virtual bool TransferToWindow();
    virtual bool Validate(wxWindow * parent);
private:
    wxString* m_valor;
    DECLARE_DYNAMIC_CLASS( cbValidator )
    DECLARE_EVENT_TABLE()
};

class combobox : public wxDialog
{
    public:
        combobox(wxWindow *wnd, datosComboBox &datos);
        virtual ~combobox();

    protected:
        enum
        {
            idComboBox = 1000
        };
        datosComboBox& data;
        wxComboBox* m_comboBox;

    private:
        void OnClose(wxCloseEvent& event);
        wxDECLARE_EVENT_TABLE();
};

#endif // COMBOBOX_H
