/***************************************************************
 * Name:      combobox.cpp
 * Purpose:   Code for Dialog combobox
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-11-27
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#include "combobox.h"

IMPLEMENT_DYNAMIC_CLASS( cbValidator, wxValidator )
BEGIN_EVENT_TABLE( cbValidator, wxValidator )
END_EVENT_TABLE()

cbValidator::cbValidator(wxString *v) : wxValidator(), m_valor(v) {}

bool cbValidator::TransferFromWindow()
{
    try {
        wxComboBox *lb = dynamic_cast<wxComboBox*>(m_validatorWindow);
        *m_valor = lb->GetValue();
    }
    catch (...) {
        wxFAIL_MSG( _T("cbValidator sólo funciona con wxComboBox"));
        return false;
    }
    return true;
}

bool cbValidator::TransferToWindow()
{
    return true;
}

bool cbValidator::Validate(wxWindow* parent)
{
    return true;
}

wxBEGIN_EVENT_TABLE(combobox, wxDialog)
    EVT_CLOSE(combobox::OnClose)
wxEND_EVENT_TABLE()

combobox::combobox(wxWindow *wnd, datosComboBox &datos)
    : wxDialog(wnd, -1, _T("Ejemplo de combobox")), data(datos)
{
    wxBoxSizer *boxVertical;
    wxBoxSizer *boxHorizontal;

    boxVertical = new wxBoxSizer(wxVERTICAL);

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    m_comboBox = new wxComboBox(this, idComboBox, data.opcion, wxDefaultPosition, wxSize(200, wxDefaultCoord), data.lista, wxCB_DROPDOWN, cbValidator(&data.opcion));
    boxHorizontal->Add(m_comboBox, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);
}

combobox::~combobox()
{
    //dtor
}

void combobox::OnClose(wxCloseEvent& event) {
    Destroy();
}


