#ifndef HEADER_50D72D48377448D6
#define HEADER_50D72D48377448D6

/***************************************************************
 * Name:      wx009Main.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-27
 * Copyright: Salvador Pozo (www.conclase.net)
 * License:
 **************************************************************/

#ifndef WX009MAIN_H
#define WX009MAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include <wx/imagpng.h>

#include "wx009App.h"
#include "combobox.h"
#include "bitmapcombobox.h"

class wx009Frame: public wxFrame
{
    public:
        wx009Frame(wxFrame *frame, const wxString& title);
        ~wx009Frame();
    private:
        enum
        {
            idMenuQuit = 1000,
            idMenuComboBox,
            idMenuBitmapComboBox,
            idMenuAbout
        };
        datosComboBox dataCombobox;
        datosBitmapComboBox dataBitmapCombobox;
        void LeerLista(wxArrayString &lista);
        void GuardarLista(wxArrayString &lista);
        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnComboBox(wxCommandEvent& event);
        void OnBitmapComboBox(wxCommandEvent& event);
        DECLARE_EVENT_TABLE()
};

#endif // WX009MAIN_H
#endif // header guard

